#include <stdio.h>
#include <allegro.h>

int main(void)
{
    PALETTE greyscale;
    int i, c;

    allegro_init();

    install_keyboard();

    if (set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0) < 0) {
	printf("%s\n", allegro_error);
	exit(1);
    }
    // First we create a greyscale palette reading the desktop palette.
    for (i = 0; i < 17; i++) {
	c = desktop_palette[i].r * 0.3 + desktop_palette[i].g * 0.5 +
	    desktop_palette[i].b * 0.2;
	greyscale[i].r = greyscale[i].g = greyscale[i].b = c;
    }
    // This hides temporarily what we are drawing
    set_palette(black_palette);

    clear(screen);
    for (i = 16 * 10; i > 0; i--)
	circlefill(screen, SCREEN_W / 2, SCREEN_H - 1, i, i / 10);

    set_palette(desktop_palette);

    clear_keybuf();
    readkey();

    vsync();
    set_palette(greyscale);

    clear_keybuf();
    readkey();

    return 0;
}
END_OF_MAIN();

