#include <stdlib.h>
#include <allegro.h>
#include "052as.h"

SQUARE_T *square_init(int new_x, int new_y, int new_width, int new_height,
		      int new_col, int new_xs, int new_ys)
{
    SQUARE_T *temp;

    // Allocate memory for the square. If unsuccessful, return NULL.
    temp = malloc(sizeof(SQUARE_T));

    if (!temp)
	return NULL;

    temp->x = new_x;
    temp->y = new_y;
    temp->w = new_width;
    temp->h = new_height;
    temp->col = new_col;
    temp->xs = new_xs;
    temp->ys = new_ys;
    temp->dx = temp->dy = 0;

    return temp;
}

void square_destroy(SQUARE_T * square)
{
    if (square)
	free(square);
}

void square_draw(SQUARE_T * square, BITMAP * bmp)
{
    rectfill(bmp, square->x, square->y,
	     square->x + square->w, square->y + square->h, square->col);

    square->dx = square->x;
    square->dy = square->y;
}

void square_update(SQUARE_T * square)
{
    // First we update the position of the square...
    square->x += square->xs;
    square->y += square->ys;

    // Now we see if it reached the maximum frame border

    if (square->x + (square->w / 2) > SCREEN_W - 5)
	square->xs *= -1;

    if (square->y + (square->h / 2) > SCREEN_H - 5)
	square->ys *= -1;

    if (square->x + (square->w / 2) < 5)
	square->xs *= -1;

    if (square->y + (square->h / 2) < 5)
	square->ys *= -1;
}

void square_erase(SQUARE_T * square, BITMAP * bmp)
{
    rectfill(bmp, square->dx, square->dy,
	     square->dx + square->w, square->dy + square->h, 0);
}
