// Header to move a circle and a square mixed in a struct.

#define     CIRCLE      11
#define     SQUARE      22

typedef struct shape_t SHAPE_T;

struct shape_t {
  int type;          // Either CIRCLE or SQUARE
  int x,y,r,w,h;     // x, y, and radius or width and height, depends on type
  int col;           // colour
  int xs,ys;         // x speed, y speed
  int dx,dy;         // drawn x, drawn y
  };

SHAPE_T *shape_init(int new_type, int new_x, int new_y, int new_radius,
                    int new_width, int new_height,
                    int new_col, int new_xs, int new_ys);

void shape_destroy (SHAPE_T *shape);
void shape_draw (SHAPE_T *shape, BITMAP *bmp);
void shape_update (SHAPE_T *shape);
void shape_erase (SHAPE_T *shape, BITMAP *bmp);

