/* Header for the input routines. All input has to be converted and
 * transformed in generic input data the program can treat.
 */

typedef struct input_t INPUT_T;

struct input_t {
   int dx, dy;          // Movement axis
   int fire1, fire2;    // Fire buttons
};

/* Do you remember the chapter with linked lists???
 * We are going to create a chain of devices. We only need simple linked
 * lists, since all our functions will begin with one device and follow
 * the chain, recovering input from each step.
 */

INPUT_T *all_input[3];     // The three input devices...

INPUT_T *input_create_joystick (void);
INPUT_T *input_create_mouse (int max_mousespeed);
INPUT_T *input_create_keybd (int left_key, int right_key,
                             int up_key, int down_key,
                             int fire1_key, int fire2_key);
int input_init (void);
void input_shutdown (void);
void input_destroy (INPUT_T *what);
void input(void);
void redefine_keyboard(void);
void calibrate_our_joystick(void);
int get_mouse_speed(void);
void change_mouse_speed(int speed);

