// Timer routines

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <allegro.h>
#include "1031tim.h"

volatile int target_cycle;

void target_incrementor()
{
    target_cycle++;
}

END_OF_FUNCTION(target_incrementor);

volatile int last_fps;
volatile int frame_counter;

void count_frames()
{
    last_fps = frame_counter;
    frame_counter = 0;
}

END_OF_FUNCTION(count_frames);

void init_custom_timers(void)
{
    srand(time(NULL));

    LOCK_VARIABLE(target_cycle);
    LOCK_FUNCTION(target_incrementor);
    install_int_ex(target_incrementor, BPS_TO_TIMER(30));
    LOCK_VARIABLE(last_fps);
    LOCK_VARIABLE(frame_counter);
    LOCK_FUNCTION(count_frames);
    install_int_ex(count_frames, BPS_TO_TIMER(1));
}

void shutdown_timers(void)
{
    remove_int(target_incrementor);
    remove_int(count_frames);
}
