#include <stdio.h>
#include <allegro.h>
#include "1032.h"

int load_our_data(void)
{
    int f;
    char string[8];

    /* Look, since this example can be run from the main src/ dir or from some
     * src/10/3.x dir, to avoid having duplicated datafiles we will try
     * loading the data from the current dir, if not found, 2 dirs up.
     * But this isn't the point of the example. The important thing is that
     * you see 'how' you have to load the data in memory.
     */

    if (file_exists("datafile.dat", 0, NULL) != 0) {
	background_object = load_datafile_object("datafile.dat", "BACKGROUND");
	font_object = load_datafile_object("datafile.dat", "CUSTOM_FONT");
	music_object = load_datafile_object("datafile.dat", "MUSIC");
	pal_object = load_datafile_object("datafile.dat", "PAL_EXAMPLE");
	walk_object = load_datafile_object("datafile.dat", "WALK");
	for (f = 1; f <= 10; f++) {
	    sprintf(string, "SPR0%2d", f);
	    sprite_object[f - 1] = load_datafile_object("datafile.dat", string);
	}
    } else {
	background_object = load_datafile_object("../../datafile.dat", "BACKGROUND");
	font_object = load_datafile_object("../../datafile.dat", "CUSTOM_FONT");
	music_object = load_datafile_object("../../datafile.dat", "MUSIC");
	pal_object = load_datafile_object("../../datafile.dat", "PAL_EXAMPLE");
	walk_object = load_datafile_object("../../datafile.dat", "WALK");
	for (f = 1; f <= 10; f++) {
	    sprintf(string, "SPR%02d", f);
	    sprite_object[f - 1] = load_datafile_object("../../datafile.dat", string);
	}
    }

    if (background_object == NULL || font_object == NULL ||
	music_object == NULL || pal_object == NULL || walk_object == NULL)
	return 1;

    for (f = 0; f < 10; f++)
	if (sprite_object[f] == NULL)
	    return 1;


    return 0;			// Data loaded.

}

void unload_our_data(void)
{
    int f;

    unload_datafile_object(background_object);
    unload_datafile_object(font_object);
    unload_datafile_object(music_object);
    unload_datafile_object(pal_object);
    unload_datafile_object(walk_object);
    for (f = 0; f < 10; f++)
	unload_datafile_object(sprite_object[f]);
}
